(function() {
  var Eventable;
  var __slice = Array.prototype.slice;
  Eventable = (function() {
    function Eventable() {}
    Eventable.prototype.listeners = {};
    Eventable.prototype.on = function(name, listener) {
      var _base;
      (_base = this.listeners)[name] || (_base[name] = []);
      return this.listeners[name].push(listener);
    };
    Eventable.prototype.emit = function() {
      var args, callback, emitter, listener, listenerCallback, listeners, name, remaining, _i, _j, _len;
      name = arguments[0], args = 3 <= arguments.length ? __slice.call(arguments, 1, _i = arguments.length - 1) : (_i = 1, []), callback = arguments[_i++];
      if (callback == null) {
        callback = function() {};
      }
      remaining = 1;
      emitter = this;
      listenerCallback = function(err) {
        if (!--remaining || err) {
          return callback(err);
        }
      };
      args.push(listenerCallback);
      listeners = this.listeners[name];
      if (listeners) {
        for (_j = 0, _len = listeners.length; _j < _len; _j++) {
          listener = listeners[_j];
          if (listener.length >= args.length) {
            remaining++;
          }
          listener.apply(this, args);
        }
      }
      return listenerCallback();
    };
    return Eventable;
  })();
  module.exports = Eventable;
}).call(this);
